/**
 **   mkUsage - make usage.c function for a C program
 **
 **  CREATED:  93.04.21  ABS  hacked together
 **/

#include "mkUsage.h"

main(argc, argv)
int argc;
char** argv;
{
    /* declare functions */

    /* declare local variables */

    int n, length;
    char temp_line[MAX_LINE];

    /* initialize local variables */

    /* initialize global variables (including parameters) */

    defaultParms();
    parseArgs(argc, argv);

    if (Debug != FALSE) {
        fprintf(stderr, "%s: DEBUG: Num = %d\n", argv[0], Num);
        }

    /* write head */

    fprintf(stdout, "/*\n");
    fprintf(stdout, " *  usage - give program usage\n");
    fprintf(stdout, " */\n");
    fprintf(stdout, "\n");
    fprintf(stdout, "#include        <stdio.h>\n");
    fprintf(stdout, "\n");
    fprintf(stdout, "usage(argv)\n");
    fprintf(stdout, "char** argv;\n");
    fprintf(stdout, "{\n");
    fprintf(stdout,
    "    fprintf(stderr, \"%%s: USAGE: %%s [flags] < infile > outfile\\n\",\n");
    fprintf(stdout, "        argv[0], argv[0]);\n");

    /* read & write */

    for (n = 0; n < Num; n++) {
        length = getl(stdin, temp_line, MAX_LINE);
        temp_line[length - 1] = (int)NULL;
        fprintf(stdout, "    fprintf(stderr, \"%s\\n\");\n", temp_line);
        } /* end for */

    /* write tail */

    fprintf(stdout, "\n");
    fprintf(stdout, "    } /* end of usage */\n");

    } /* end main */

/*
 *  defaultParms - initialize global variables
 */
defaultParms()
{
    Debug = FALSE;
    Num = 1;

    } /* end defaultParms() */

/*
 *  parseArgs - parse arguments into global variables
 */
parseArgs(argc, argv)
int argc;
char** argv;
{
    int i;

    for (i = 0; i < argc; i++) {
        if (argv[i][0] == '-') {
            switch (argv[i][1]) {
                case 'D' : Debug = TRUE;
                           break;
                case 'n' : Num = atoi(&argv[++i][0]);
                           break;
                default:   fprintf(stderr, "%s: ERROR: illegal flag: %s\n",
                               argv[0], argv[i]);
                           exit(0);
                           break;
                } /* end switch */
            } /* end if */
        } /* end for(i) */
    } /* end parseArgs() */

/*
 * getl - modified from Kernighan & Ritchie to take stream
 */
int
getl(stream, s, lim)            /* get line into s, return length */
FILE *stream;
char s[];
int lim;
{
    int c, i;

    i = 0;
    while (--lim > 0 && (c = getc(stream)) != EOF && c != '\n')
        s[i++] = c;
    if (c == '\n')
        s[i++] = c;
    s[i] = '\0';
    return(i);
    } /* end getl() */
